'境界面の一括設定ﾌﾟﾛｸﾞﾗﾑ

Public Class FL3DDat3a
    Dim KindCylinder As Integer '円筒面の式（0:なし、1:XY式、2:YZ式、3:ZX式）

    Dim Ac As Single            '中心座標A値
    Dim Bc As Single            '中心座標B値

    Dim KAxis(3) As Integer     '座標軸指定の有無

    Dim Rrange(2) As Single     '半径R範囲
    Dim Xrange(2) As Single     'X座標範囲
    Dim Yrange(2) As Single     'Y座標範囲
    Dim Zrange(2) As Single     'Z座標範囲

    Private Sub BoundAdd(ByVal i As Integer, ByVal j As Integer)
        '境界の追加
        'i･･･要素番号
        'j･･･面番号
        Dim ii, jj, nb As Integer

        Select Case KindBoundS
            Case 0
                nb = NboundS + 1
                Dim nbuf1(NboundS, 2), jbuf2(NboundS, Ndim) As Integer
                Dim buf3(NboundS, Ndim) As Single
                For ii = 1 To NboundS
                    For jj = 1 To 2
                        nbuf1(ii, jj) = KsurfRest(ii, jj)
                    Next jj
                    For jj = 1 To Ndim
                        jbuf2(ii, jj) = JfixS(ii, jj)
                        buf3(ii, jj) = VfixS(ii, jj)
                    Next jj
                Next ii
                ReDim KsurfRest(nb, 2), JfixS(nb, Ndim), VfixS(nb, Ndim)
                For ii = 1 To NboundS
                    For jj = 1 To 2
                        KsurfRest(ii, jj) = nbuf1(ii, jj)
                    Next jj
                    For jj = 1 To Ndim
                        JfixS(ii, jj) = jbuf2(ii, jj)
                        VfixS(ii, jj) = buf3(ii, jj)
                    Next jj
                Next ii
                KsurfRest(nb, 1) = i
                KsurfRest(nb, 2) = j
                If IncVisc = 0 Then
                    VfixS(nb, 1) = BoundSVal(1, 1)
                Else
                    For jj = 1 To Ndim
                        JfixS(nb, jj) = BoundSVal(jj, 1)
                        VfixS(nb, jj) = BoundSVal(jj, 2)
                    Next jj
                End If
                NboundS = nb
            Case 1
                If IncVisc = 0 Then
                    Call FluxSet(i, j)  '流束の設定
                Else
                    nb = NBtempS + 1
                    Dim nbuf1(NBtempS, 2) As Integer
                    Dim buf2(NBtempS) As Single
                    For ii = 1 To NBtempS
                        For jj = 1 To 2
                            nbuf1(ii, jj) = KsurfTrest(ii, jj)
                        Next jj
                        buf2(ii) = TempFixS(ii)
                    Next ii
                    ReDim KsurfTrest(nb, 2), TempFixS(nb)
                    For ii = 1 To NBtempS
                        For jj = 1 To 2
                            KsurfTrest(ii, jj) = nbuf1(ii, jj)
                        Next jj
                        TempFixS(ii) = buf2(ii)
                    Next ii
                    KsurfTrest(nb, 1) = i
                    KsurfTrest(nb, 2) = j
                    TempFixS(nb) = BoundSVal(1, 1)
                    NBtempS = nb
                End If
            Case 2
                Call FluxSet(i, j)  '流束の設定
        End Select

    End Sub

    Private Sub BoundSet()
        '境界の一括設定
        Dim i, ic, j, jmax, k, kmax As Integer
        Dim xb, yb, zb As Single

        If KindElem = 0 Then
            jmax = 6
            kmax = 8
        End If
        Call ElemPrep()     '要素準備
        Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
        For i = 1 To Nelem
            For j = 1 To jmax
                ic = 0
                If KSelem(i, j) = 0 Then
                    If KindElem = 0 Then
                        Call SurfaceSet(i, j, KsurfPoint)     '面の設定
                    End If
                    For k = 1 To kmax
                        xb = Xdata(KsurfPoint(k))
                        yb = Ydata(KsurfPoint(k))
                        zb = Zdata(KsurfPoint(k))
                        Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
                    Next k
                    If ic = 0 Then
                        Call BoundAdd(i, j)  '境界設定の追加
                    End If
                End If
            Next j
        Next i

    End Sub

    Private Sub CondCheck(ByRef ic As Integer)
        '条件ﾁｪｯｸ
        'ic･･･ｴﾗｰ種別（-2:条件なし、-1：範囲ｴﾗｰ）
        If KAxis(1) > 0 Then
            ic = 1
            If Xrange(1) > Xrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            ic = 1
            If Yrange(1) > Yrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            ic = 1
            If Zrange(1) > Zrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            ic = 1
            If Rrange(1) > Rrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If ic = 0 Then
            ic = -2
        End If

    End Sub

    Private Sub CondCheck2(ByRef ic As Integer, ByVal xb As Single, _
        ByVal yb As Single, ByVal zb As Single)
        '条件ﾁｪｯｸ2
        'ic･･･条件外れ有無（0:条件内、1:条件外れ）
        'xb,yb,zb･･･点の座標
        Dim b1, b2, b3 As Single
        If KAxis(1) > 0 Then
            If xb < Xrange(1) Or xb > Xrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            If yb < Yrange(1) Or yb > Yrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            If zb < Zrange(1) Or zb > Zrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            Select Case KindCylinder
                Case 1
                    b1 = xb - Ac
                    b2 = yb - Bc
                Case 2
                    b1 = yb - Ac
                    b2 = zb - Bc
                Case 3
                    b1 = zb - Ac
                    b2 = xb - Bc
            End Select
            b3 = Math.Sqrt(b1 * b1 + b2 * b2)
            If b3 < Rrange(1) Or b3 > Rrange(2) Then
                ic = 1
            End If
        End If

    End Sub

    Private Sub ElemPrep()
        '要素準備
        Dim ie As Integer
        ReDim KdrawElem(Nelem), KSelem(Nelem, 6)

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie

    End Sub

    Private Sub FluxSet(ByVal i As Integer, ByVal j As Integer)
        '流束の設定
        'i･･･要素番号
        'j･･･面番号
        Dim ii, jj, nb As Integer
        nb = Nflux + 1
        Dim nbuf1(Nflux, 2) As Integer
        Dim buf2(Nflux) As Single

        For ii = 1 To Nflux
            For jj = 1 To 2
                nbuf1(ii, jj) = KsurfFlux(ii, jj)
            Next jj
            buf2(ii) = Pnorm(ii)
        Next ii
        ReDim KsurfFlux(nb, 2), Pnorm(nb)
        For ii = 1 To Nflux
            For jj = 1 To 2
                KsurfFlux(ii, jj) = nbuf1(ii, jj)
            Next jj
            Pnorm(ii) = buf2(ii)
        Next ii
        KsurfFlux(nb, 1) = i
        KsurfFlux(nb, 2) = j
        Pnorm(nb) = BoundSVal(1, 1)
        Nflux = nb

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ic, ix As Integer

        If CheckBox1.Checked = True Then
            KAxis(1) = 1
            Xrange(1) = Val(TextBox1.Text)
            Xrange(2) = Val(TextBox2.Text)
        Else
            KAxis(1) = 0
        End If
        If CheckBox2.Checked = True Then
            KAxis(2) = 1
            Yrange(1) = Val(TextBox3.Text)
            Yrange(2) = Val(TextBox4.Text)
        Else
            KAxis(2) = 0
        End If
        If CheckBox3.Checked = True Then
            KAxis(3) = 1
            Zrange(1) = Val(TextBox5.Text)
            Zrange(2) = Val(TextBox6.Text)
        Else
            KAxis(3) = 0
        End If
        If CheckBox4.Checked = True Then
            If RadioButton1.Checked = True Then
                KindCylinder = 1
            ElseIf RadioButton2.Checked = True Then
                KindCylinder = 2
            Else
                KindCylinder = 3
            End If
            Ac = Val(TextBox7.Text)
            Bc = Val(TextBox8.Text)
            Rrange(1) = Val(TextBox9.Text)
            Rrange(2) = Val(TextBox10.Text)
        Else
            KindCylinder = 0
        End If

        ic = 0
        Call CondCheck(ic)  '条件ﾁｪｯｸ
        If ic = -2 Then
            aa$ = "条件が設定されていません！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        ElseIf ic = -1 Then
            aa$ = "条件範囲が間違っています！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        End If

        Call BoundSet()     '境界の一括設定
        KdataChange = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New AnalDat6() '解析用ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim frm As Form = New FL3DDat3() '境界一括設定の変数値の入力
        frm.Show()
        Me.Close()

    End Sub

    Private Sub FL3DDat3a_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim aa$

        aa$ = ""
        Select Case KindBoundS
            Case 0
                If IncVisc = 0 Then
                    aa$ = "速度ポテンシャル固定"
                Else
                    aa$ = "速度・圧力固定"
                End If
            Case 1
                If IncVisc = 0 Then
                    aa$ = "垂直流速固定"
                Else
                    aa$ = "温度固定"
                End If
            Case 2
                aa$ = "熱流束固定"
        End Select
        Label1.Text = aa$ + "境界面の一括設定"
        RadioButton1.Checked = True

    End Sub
End Class